/*
  ==============================================================================

    This file was auto-generated!

  ==============================================================================
*/

#include "MainComponent.h"

//==============================================================================
MainComponent::MainComponent()
{
    setSize (600, 400);
    
    setLookAndFeel(&numboxLookAndFeel);
    
    // INC/DEC BUTTONS
    //numBox.setLookAndFeel(&numboxLookAndFeel);    // always do this first!
    addAndMakeVisible(numBox);
    numBox.setSliderStyle (Slider::IncDecButtons);
    numBox.setIncDecButtonsMode (Slider::incDecButtonsDraggable_Vertical);
    numBox.setTextBoxStyle (Slider::TextBoxLeft, false, 80, 20);
    numBox.setRange (-64, 64, 1);
    numBox.setNumDecimalPlacesToDisplay(0);

    // LINEAR SLIDER
    addAndMakeVisible(slider);
    slider.setSliderStyle (Slider::LinearHorizontal);
    slider.setTextBoxStyle (Slider::TextBoxRight, false, 80, 20);
    slider.setRange (-64, 64, 1);
    //slider.setTextBoxStyle (Slider::NoTextBox, false, 0, 0);
    //panKnob.setPopupDisplayEnabled (true, false, &mainComponent);
    //panKnob.setTextValueSuffix (" dB");
    slider.setNumDecimalPlacesToDisplay(1);   // do after setRange()
    //panKnob.setSkewFactor(4);
    slider.setSliderSnapsToMousePosition(false);
    slider.setMouseDragSensitivity(50);
    slider.setDoubleClickReturnValue(true, 1.0);
    slider.setValue(0);
    
    addAndMakeVisible(bar);
    bar.setSliderStyle (Slider::LinearBar);
    bar.setTextBoxStyle (Slider::TextBoxRight, false, 80, 20);
    bar.setRange (-64, 64, 1);


    // STANDARD LABEL
    //label.setLookAndFeel(&numboxLookAndFeel);
    addAndMakeVisible(label);
    label.setText("Label Text", dontSendNotification);
    label.setEditable(true);

    // ROTARY SLIDER
    panKnob.setLookAndFeel(&rotaryLookAndFeel);
    addAndMakeVisible(panKnob);
    panKnob.setSliderStyle (Slider::RotaryVerticalDrag);
    panKnob.setRange (-64, 64, 1);
    panKnob.setTextBoxStyle (Slider::NoTextBox, false, 0, 0);
    //panKnob.setPopupDisplayEnabled (true, false, &mainComponent);
    //panKnob.setTextValueSuffix (" dB");
    panKnob.setNumDecimalPlacesToDisplay(1);   // do after setRange()
    //panKnob.setSkewFactor(4);
    panKnob.setSliderSnapsToMousePosition(false);
    panKnob.setMouseDragSensitivity(50);
    panKnob.setDoubleClickReturnValue(true, 1.0);
    panKnob.setValue(0);
    
    // ROTARY LABEL
    panLabel.setLookAndFeel(&rotaryLookAndFeel);
    addAndMakeVisible(panLabel);
    panLabel.setText("P", dontSendNotification);
    panLabel.setJustificationType(Justification::centred);
    
    // TEXT EDITOR
    addAndMakeVisible(editor);
    editor.setTextToShowWhenEmpty("I'm empty...", Colours::lightgrey);
    editor.setText("Text Editor");
    editor.setSelectAllWhenFocused (true);
    // when losing focus, clear any selection
    editor.onFocusLost = [this] {
        Range<int> range(0,0);
        editor.setHighlightedRegion(range);  // clear any selection
    };
}

MainComponent::~MainComponent()
{
    //panKnob.setLookAndFeel(nullptr);
    //panLabel.setLookAndFeel(nullptr);

    //numBox.setLookAndFeel(nullptr);
    //label.setLookAndFeel(nullptr);
    
    setLookAndFeel(nullptr);
}

//==============================================================================
void MainComponent::paint (Graphics& g)
{
    g.fillAll  (Colours::darkgrey);


    Path path;
    Rectangle<float> r (250,250,20,40);
    
    r.reduce(0.5f, 0.5f);
    
    path.addRectangle (r);
    float y = r.getY() + (r.getHeight() / 2) + 0.5f;
    Line<float> line(r.getX(), y, r.getX() + r.getWidth(), y);
    path.addLineSegment(line.toFloat(), 0.0f);
    
    
    //Rectangle<int> ri = layout.sliderBounds;
    //Line<int> li(ri.getX(), ri.getHeight() / 2, ri.getX() + ri.getWidth(), ri.getHeight() / 2);
    //path.addLineSegment(line.toFloat(), 0.0f);
    
    PathStrokeType strokeType (1.0f, PathStrokeType::JointStyle::mitered, PathStrokeType::EndCapStyle::butt);
    //float dashLengths[2] = { 4.f, 3.f };
    //strokeType.createDashedStroke (path, path, dashLengths, numElementsInArray (dashLengths));
    //g.setColour (findColour(ComboBox::backgroundColourId));
    //g.fillPath (path);
    g.setColour (Colours::white);
    g.strokePath (path, strokeType);
    
}

void MainComponent::resized()
{
    panKnob.setBounds(20,20,28,28);
    auto knobArea = panKnob.getBounds();
    panLabel.setBounds(knobArea.withSizeKeepingCentre(10, 10));
    
    numBox.setBounds(20, 100, 100, 20);
    label.setBounds(20, 150, 100, 20);
    
    slider.setBounds(20, 200, 200, 20);

    bar.setBounds(20, 250, 200, 20);

    editor.setBounds(20, 300, 200, 20);
}

#pragma mark ==== RotaryLookAndFeel
RotaryLookAndFeel::RotaryLookAndFeel()
{
    // Slider has 9 defined colors
    // only these three work on a rotary slider (without a text box)
    setColour (Slider::thumbColourId, Colours::red);                // thumb
    setColour (Slider::rotarySliderFillColourId, Colours::yellow);  // filled part
    setColour (Slider::rotarySliderOutlineColourId, Colours::grey); // unfilled part
}

void RotaryLookAndFeel::drawLabel (Graphics& g, Label& label)
{
    g.fillAll (label.findColour (Label::backgroundColourId));
    //g.fillAll (Colours::darkslategrey);
    
    if (! label.isBeingEdited())
    {
        auto alpha = label.isEnabled() ? 1.0f : 0.5f;
        const Font font (getLabelFont (label));
        
        g.setColour (label.findColour (Label::textColourId).withMultipliedAlpha (alpha));
        //g.setFont (font);
        
        g.setFont (12.0);   // srk: make small
        
        //auto textArea = getLabelBorderSize (label).subtractedFrom (label.getLocalBounds());
        auto textArea = label.getLocalBounds();

        //g.drawFittedText (label.getText(), textArea, label.getJustificationType(),
        //                  jmax (1, (int) (textArea.getHeight() / font.getHeight())),
       //                   label.getMinimumHorizontalScale());
        g.drawFittedText (label.getText(), textArea, label.getJustificationType(), 1, 1.0f);

        g.setColour (label.findColour (Label::outlineColourId).withMultipliedAlpha (alpha));
    }
    else if (label.isEnabled())
    {
        g.setColour (label.findColour (Label::outlineColourId));
    }
    
    g.drawRect (label.getLocalBounds());
}

void RotaryLookAndFeel::drawRotarySlider (Graphics& g, int x, int y, int width, int height, float sliderPos,
                                       const float rotaryStartAngle, const float rotaryEndAngle, Slider& slider)
{
    auto outline = slider.findColour (Slider::rotarySliderOutlineColourId);
    auto fill    = slider.findColour (Slider::rotarySliderFillColourId);
    
    auto bounds = Rectangle<int> (x, y, width, height).toFloat().reduced (2);   // was 10
    
    auto radius = jmin (bounds.getWidth(), bounds.getHeight()) / 2.0f;
    auto toAngle = rotaryStartAngle + sliderPos * (rotaryEndAngle - rotaryStartAngle);
    //auto lineW = jmin (8.0f, radius * 0.5f);
    auto lineW = 4.0f;
    auto arcRadius = radius - lineW * 0.5f;
    
    
    Path backgroundArc;
    backgroundArc.addCentredArc (bounds.getCentreX(),
                                 bounds.getCentreY(),
                                 arcRadius,
                                 arcRadius,
                                 0.0f,
                                 rotaryStartAngle,
                                 rotaryEndAngle,
                                 true);
    g.setColour (outline);
    //g.strokePath (backgroundArc, PathStrokeType (lineW, PathStrokeType::curved, PathStrokeType::rounded));
    g.strokePath (backgroundArc, PathStrokeType (lineW, PathStrokeType::beveled, PathStrokeType::square));

    if (slider.isEnabled())
    {
        Path valueArc;
        valueArc.addCentredArc (bounds.getCentreX(),
                                bounds.getCentreY(),
                                arcRadius,
                                arcRadius,
                                0.0f,
                                rotaryStartAngle,
                                toAngle,
                                true);
        
        g.setColour (fill);
        //g.strokePath (valueArc, PathStrokeType (lineW, PathStrokeType::curved, PathStrokeType::rounded));
        g.strokePath (valueArc, PathStrokeType (lineW, PathStrokeType::beveled, PathStrokeType::square));
    }
    
    //auto thumbWidth = lineW * 2.0f;
    auto thumbWidth = lineW * 1.2f;
    Point<float> thumbPoint (bounds.getCentreX() + arcRadius * std::cos (toAngle - MathConstants<float>::halfPi),
                             bounds.getCentreY() + arcRadius * std::sin (toAngle - MathConstants<float>::halfPi));
    
    g.setColour (slider.findColour (Slider::thumbColourId));
    g.fillEllipse (Rectangle<float> (thumbWidth, thumbWidth).withCentre (thumbPoint));
    //g.fillRect (Rectangle<float> (thumbWidth, thumbWidth).withCentre (thumbPoint));
}

#pragma mark ==== NumboxLookAndFeel
NumboxLookAndFeel::NumboxLookAndFeel()
{
 // ComboBox
/*    enum      ColourIds {
        backgroundColourId = 0x1000b00, textColourId = 0x1000a00, outlineColourId = 0x1000c00, buttonColourId = 0x1000d00,
        arrowColourId = 0x1000e00, focusedOutlineColourId = 0x1000f00
    }*/
 
    // TextButton has 4 defined colors:
//    enum      ColourIds { buttonColourId = 0x1000100, buttonOnColourId = 0x1000101, textColourOffId = 0x1000102, textColourOnId = 0x1000103 }
    
    // Slider has 9 defined colors
    // inc/decs, or text box when visible
    setColour(Slider::textBoxBackgroundColourId, Colours::indigo);      // numbox background
    setColour(Slider::textBoxOutlineColourId, Colours::white);          // numbox outline
    setColour(Slider::textBoxTextColourId, Colours::yellow);            // text when displayed
    setColour(Slider::textBoxHighlightColourId, Colours::linen);        // highlight (Slider only!)
    // horizontal/vertical/rotary slider:
    setColour(Slider::thumbColourId, Colours::hotpink);                 // thumb on either
    // horizontal/vertical slider only:
    setColour(Slider::backgroundColourId, Colours::darkolivegreen);     // background (unfilled part)
    setColour(Slider::trackColourId, Colours::darkgoldenrod);           // track (filled part)
    // rotary slider only:
    setColour(Slider::rotarySliderFillColourId, Colours::black);
    setColour(Slider::rotarySliderOutlineColourId, Colours::mediumspringgreen);
    
    // Label has 6 defined colors:
    // works on a Label in display state:
    setColour(Label::backgroundColourId, Colours::maroon);
    setColour(Label::textColourId, Colours::orange);
    setColour(Label::outlineColourId, Colours::teal);

    // the other 3 apply to text-editing,on both Slider and Label
    setColour(Label::backgroundWhenEditingColourId, Colours::pink);     // text editor background
    setColour(Label::outlineWhenEditingColourId, Colours::purple);      // text editor outline
    setColour(Label::textWhenEditingColourId, Colours::red);            // unhighlighted text, new text
    
    // TextEditor has 7 defined colors:
    // the first also applies to Slider and Label for text-editing
    setColour(TextEditor::highlightedTextColourId, Colours::blue);      // highlighted text
    // the second applies also to Label (but not Slider)
    setColour(TextEditor::highlightColourId, Colours::red);             // highlight (Label only!)

    // the other 5 affect a TextEditor, but not Slider or Label
    setColour(TextEditor::backgroundColourId, Colours::white);          // text editor background
    setColour(TextEditor::outlineColourId, Colours::black);             // text editor outline
    setColour(TextEditor::textColourId, Colours::turquoise);            // displayed, unhighlighted text, new text
    setColour(TextEditor::focusedOutlineColourId, Colours::yellow);     // outline when focused
    // used in LookAndFeel_V2, but not V4:
    setColour(TextEditor::shadowColourId, Colours::black);              // interior frame shadow
}
Button* NumboxLookAndFeel::createSliderButton (Slider&, const bool isIncrement)
{
    Path path;
    path.addTriangle (0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 0.5f);
    //path.addTriangle (0.0f, 0.5f, 0.0f, 1.0f, 1.0f, 0.75f);
    
    // for the down position
    String name = "d";
    float arrowDirectionInRadians = 0.25f;
    
    
    if (isIncrement)
    {
        name = "u";
        arrowDirectionInRadians = 0.75f;
    }
    path.applyTransform (AffineTransform::rotation (MathConstants<float>::twoPi * arrowDirectionInRadians, 0.5f, 0.5f));
    
    ShapeButton* sb = new ShapeButton(name,
                                      findColour (ResizableWindow::backgroundColourId),      // normal
                                      Colours::yellow,   // over
                                      Colours::green);   // down
    
    //sb->setShape (path, false, true, false);
    sb->setShape (path, false, false, false);     // booleans: resize now, maintain proportions, has shadow
    sb->setOutline(Colours::lightgrey, 1.0f);
    BorderSize<int> bs(1);
    
    /*
     if (isIncrement)
     bs.setBottom(1);
     else
     bs.setTop(1);
     */
    sb->setBorderSize(bs);
    
    return sb;
}

Slider::SliderLayout NumboxLookAndFeel::getSliderLayout (Slider& slider)
{
    // from LookAndFeel_V2
    
    // 1. compute the actually visible textBox size from the slider textBox size and some additional constraints
    
    int minXSpace = 0;      // srk: this is actually the space reserved for the incdec buttons
    int minYSpace = 0;
    
    auto textBoxPos = slider.getTextBoxPosition();
    
    auto sliderStyle = slider.getSliderStyle();  // srk
    
    if (textBoxPos == Slider::TextBoxLeft || textBoxPos == Slider::TextBoxRight)
        if (sliderStyle == Slider::IncDecButtons)   // srk
            minXSpace = 18; // srk
        else
            minXSpace = 30;
    else
        minYSpace = 15;
    
    auto localBounds = slider.getLocalBounds();
    
    auto textBoxWidth  = jmax (0, jmin (slider.getTextBoxWidth(),  localBounds.getWidth() - minXSpace));
    auto textBoxHeight = jmax (0, jmin (slider.getTextBoxHeight(), localBounds.getHeight() - minYSpace));
    
    Slider::SliderLayout layout;
    
    // 2. set the textBox bounds
    
    if (textBoxPos != Slider::NoTextBox)
    {
        if (slider.isBar())
        {
            layout.textBoxBounds = localBounds;
        }
        else
        {
            layout.textBoxBounds.setWidth (textBoxWidth);
            layout.textBoxBounds.setHeight (textBoxHeight);
            
            if (textBoxPos == Slider::TextBoxLeft)           layout.textBoxBounds.setX (0);
            else if (textBoxPos == Slider::TextBoxRight)     layout.textBoxBounds.setX (localBounds.getWidth() - textBoxWidth);
            else /* above or below -> centre horizontally */ layout.textBoxBounds.setX ((localBounds.getWidth() - textBoxWidth) / 2);
            
            if (textBoxPos == Slider::TextBoxAbove)          layout.textBoxBounds.setY (0);
            else if (textBoxPos == Slider::TextBoxBelow)     layout.textBoxBounds.setY (localBounds.getHeight() - textBoxHeight);
            else /* left or right -> centre vertically */    layout.textBoxBounds.setY ((localBounds.getHeight() - textBoxHeight) / 2);
        }
    }
    
    // 3. set the slider bounds
    
    layout.sliderBounds = localBounds;
    
    if (slider.isBar())
    {
        layout.sliderBounds.reduce (1, 1);   // bar border
    }
    else
    {
        if (textBoxPos == Slider::TextBoxLeft)       layout.sliderBounds.removeFromLeft (textBoxWidth);
        else if (textBoxPos == Slider::TextBoxRight) layout.sliderBounds.removeFromRight (textBoxWidth);
        else if (textBoxPos == Slider::TextBoxAbove) layout.sliderBounds.removeFromTop (textBoxHeight);
        else if (textBoxPos == Slider::TextBoxBelow) layout.sliderBounds.removeFromBottom (textBoxHeight);
        
        const int thumbIndent = getSliderThumbRadius (slider);
        
        if (slider.isHorizontal())    layout.sliderBounds.reduce (thumbIndent, 0);
        else if (slider.isVertical()) layout.sliderBounds.reduce (0, thumbIndent);
        
     }
    // can we make a drawable here?
    if (sliderStyle == Slider::IncDecButtons)   // srk
    {
        Parallelogram<float> p (layout.sliderBounds.toFloat());
        
        //static DrawableRectangle dr;
        dr.setRectangle(p);
     
        slider.addAndMakeVisible(dr);
    }

    return layout;
}

Label* NumboxLookAndFeel::createSliderTextBox (Slider& slider)
{
    auto* l = LookAndFeel_V2::createSliderTextBox (slider);

    /* srk: seems unneeded, since we are specifying colours that override this
    if (getCurrentColourScheme() == LookAndFeel_V4::getGreyColourScheme() && (slider.getSliderStyle() == Slider::LinearBar
                                                                              || slider.getSliderStyle() == Slider::LinearBarVertical))
    {
        l->setColour (Label::textColourId, Colours::black.withAlpha (0.7f));
    }
*/
    // srk: using this to set the justification:
    l->setJustificationType(Justification::left);
    
    return l;
}

void NumboxLookAndFeel::fillTextEditorBackground (Graphics& g, int /*width*/, int /*height*/, TextEditor& textEditor)
{
    g.fillAll (textEditor.findColour (TextEditor::backgroundColourId));
    
    // srk: using this just to hide the blinking caret
    //textEditor.setCaretVisible(false);
}

/*
    static void drawBevel (Graphics&,
                           int x, int y, int width, int height,
                           int bevelThickness,
                           const Colour& topLeftColour = Colours::white,
                           const Colour& bottomRightColour = Colours::black,
                           bool useGradient = true,
                           bool sharpEdgeOnOutside = true);

 */
/*
void NumboxLookAndFeel::drawTextEditorOutline (Graphics& g, int width, int height, TextEditor& textEditor)
{
    if (dynamic_cast<AlertWindow*> (textEditor.getParentComponent()) == nullptr)
    {
        if (textEditor.isEnabled())
        {
            if (textEditor.hasKeyboardFocus (true) && ! textEditor.isReadOnly())
            {
                g.setColour (textEditor.findColour (TextEditor::focusedOutlineColourId));
                g.drawRect (0, 0, width, height, 2);
            }
            else
            {
                g.setColour (textEditor.findColour (TextEditor::outlineColourId));
                g.drawRect (0, 0, width, height);
            }
        }
    }
}

*/
void NumboxLookAndFeel::drawTextEditorOutline (Graphics& g, int width, int height, TextEditor& textEditor)
{
    // took from V2 just to play with shadow
    
    if (textEditor.isEnabled())
    {
        if (textEditor.hasKeyboardFocus (true) && ! textEditor.isReadOnly())
        {
            const int border = 2;
            
            g.setColour (textEditor.findColour (TextEditor::focusedOutlineColourId));
            g.drawRect (0, 0, width, height, border);
            
            g.setOpacity (1.0f);
            auto shadowColour = textEditor.findColour (TextEditor::shadowColourId).withMultipliedAlpha (0.25f);
            //drawBevel (g, 0, 0, width, height + 2, border + 2, shadowColour, shadowColour);
            drawBevel (g, border, border, width - (border*2), height - (border*2), border, shadowColour, shadowColour);
        }
        else
        {
            g.setColour (textEditor.findColour (TextEditor::outlineColourId));
            g.drawRect (0, 0, width, height);
            
            /*
            g.setOpacity (1.0f);
            auto shadowColour = textEditor.findColour (TextEditor::shadowColourId);
            drawBevel (g, 0, 0, width, height + 2, 3, shadowColour, shadowColour);
             */
        }
    }
}

