/*
  ==============================================================================

    This file was auto-generated!

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"

//==============================================================================
/*
    This component lives inside our window, and this is where you should put all
    your controls and content.
*/
class RotaryLookAndFeel : public LookAndFeel_V4
{
public:
    RotaryLookAndFeel();
    
    void drawLabel (Graphics& g, Label& label);
    void drawRotarySlider (Graphics& g, int x, int y, int width, int height, float sliderPos,
                           const float rotaryStartAngle, const float rotaryEndAngle, Slider& slider);
private:
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (RotaryLookAndFeel)
};

class NumboxLookAndFeel : public LookAndFeel_V4
{
public:
    NumboxLookAndFeel();
    
    Button* createSliderButton (Slider&, const bool isIncrement);
    Slider::SliderLayout getSliderLayout (Slider& slider);
    Label* createSliderTextBox (Slider& slider);
    // using this just to hide the blinking caret
    void fillTextEditorBackground (Graphics& g, int /*width*/, int /*height*/, TextEditor& textEditor);

    void drawTextEditorOutline (Graphics& g, int width, int height, TextEditor& textEditor);

private:
    DrawableRectangle dr;

    
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (NumboxLookAndFeel)
};


class MainComponent   : public Component
{
public:
    //==============================================================================
    MainComponent();
    ~MainComponent();

    //==============================================================================
    void paint (Graphics&) override;
    void resized() override;
    void mouseDown (const MouseEvent& /*event*/) override { unfocusAllComponents(); }

private:
    //==============================================================================
    // Your private member variables go here...
    RotaryLookAndFeel rotaryLookAndFeel;
    NumboxLookAndFeel numboxLookAndFeel;
    
    Slider panKnob;
    Label panLabel;
    
    Slider numBox;
    Label label;
    
    Slider slider;
    
    Slider bar;
    
    TextEditor editor;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MainComponent)
};
